> For the complete documentation index, see [llms.txt](https://docs.balena.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.balena.io/reference/api/resources/download.md).

# Download balenaOS

## Examples

### Download private or ESR balenaOS images

In order to download an ESR or private balenaOS image, you need to provide your bearer token. The `deviceType` and `version` parameters are required. Add an `--output` flag to provide a path for the image to be downloaded.

```bash
GET "https://api.balena-cloud.com/download?deviceType=<DEVICE NAME>&version=<BALENAOS VERSION>&fileType=.zip'" \
-H "Content-Type: application/octet-stream" \
-H "Authorization: Bearer <AUTH_TOKEN>" 
```

### Download public balenaOS images

Same as above but the auth header is optional to use. The `deviceType` and `version` parameters are required. These releases also available for download on balena.io/os and the dashboard.

```bash
GET "https://api.balena-cloud.com/download?deviceType=<DEVICE NAME>&version=<BALENAOS VERSION>&fileType=.gz'" \
-H "Content-Type: application/octet-stream" \
-H "Authorization: Bearer <AUTH_TOKEN>" 
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.balena.io/reference/api/resources/download.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
